<id>
Mozilla Sidebar
</id>

<version>
1.0
</version>

<mod info>
Adds a sidebar for Mozilla/Netscape to your YaBB Board.
To add a button to your sidebar on your homepage, simply add the following code to your site:

<script language="JavaScript">
<!--
function addPanel(){
  if ((typeof window.sidebar == "object") && (typeof window.sidebar.addPanel == "function")) {
    window.sidebar.addPanel ("YOUR_BOARD_TITLE","YOUR_BOARD_URL?action=sidebar","");
  } else {
    var rv = window.confirm ("This page is enhanced for use with Mozilla." + "Would you like to visit Mozilla's website?");
    if (rv)
      document.location.href = "http://www.mozilla.org";
  }
}
//-->
</script>
<a href="javascript:addPanel();">Add Sidebar</a>

(replace YOUR_BOARD_TITLE and YOUR_BOARD_URL by your needs, for example "My YaBB" and "http://bla.com/YaBB.pl").
Next upload template_sidebar.html to your YaBB directory. You can access your sidebar through http://www.yourboard.com/YaBB.pl?action=sidebar

Note: this mod was originally Hinkle's idea so all credits to him :-)
</mod info>

<author>
Michael Prager
</author>

<homepage>
http://www.boardmod.org
</homepage>

<edit file>
YaBB.pl
</edit file>

<search for>
#END FASTFIND S*
</search for>

<add before>
	elsif ($action eq 'sidebar') { &ShowSidebar; }
</add before>

<edit file>
Sources/Subs.pl
</edit file>

<search for>
sub template {
</search for>

<add before>
sub ShowSidebar {
	# Open the file with all categories
	fopen(FILE, "$vardir/cat.txt");
	@categories = <FILE>;
	fclose(FILE);
	my($memcount, $latestmember) = &MembershipGet;
	$totalm = 0;
	$totalt = 0;
	foreach $curcat (@categories) {
		chomp $curcat;
		fopen(FILE, "$boardsdir/$curcat.cat");
		$catname{$curcat} = <FILE>;
		chomp $catname{$curcat};
		$cataccess{$curcat} = <FILE>;
		chomp $cataccess{$curcat};
		@{$catboards{$curcat}} = <FILE>;
		fclose(FILE);
		@membergroups = split( /,/, $cataccess{$curcat} );
		$openmemgr{$curcat} = 0;
		foreach $tmpa (@membergroups) { if($tmpa eq $settings[7]) { $openmemgr{$curcat} = 1; last; } }
		if(!$cataccess{$curcat} || $settings[7] eq 'Administrator') { $openmemgr{$curcat} = 1; }
		unless($openmemgr{$curcat}) { next; }
		foreach $curboard (@{$catboards{$curcat}}) {
			chomp $curboard;
			( $threadcount, $messagecount, $lastposttime, $lastposter ) = &BoardCountGet($curboard);
			$lastposttime{$curboard} = $lastposttime eq 'N/A' || ! $lastposttime ? $txt{'470'} : &timeformat($lastposttime);
			$lastpostrealtime{$curboard} = $lastposttime eq 'N/A' || ! $lastposttime ? '' : $lastposttime;
			if( $lastposter =~ m~\AGuest-(.*)~ ) {
				$lastposter = $1;
				$lastposterguest{$curboard} = 1;
			}
			$lastposter{$curboard} = $lastposter eq 'N/A' || ! $lastposter ? $txt{'470'} : $lastposter;
			$messagecount{$curboard} = $messagecount || 0;
			$threadcount{$curboard} = $threadcount || 0;
			$totalm += $messagecount;
			$totalt += $threadcount;
		}
	}

	$yymain .= qq~
<table border=0 width="100%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor">
  <tr>
    <td>
    <table cellpadding="4" cellspacing="1" border="0" width="100%">~;

	foreach $curcat (@categories) {
		unless( $openmemgr{$curcat} ) { next; }
		$yymain .= qq~<tr>
        <td colspan="2" class="catbg" bgcolor="$color{'catbg'}" height="18"><a name="$curcat"> <font size=2><b>$catname{$curcat}</b></font></a></td>
      </tr>~;
		foreach $curboard (@{$catboards{$curcat}}) {
			chomp $curboard;
			fopen(FILE, "$boardsdir/$curboard.dat");
			$curboardname = <FILE>;
			chomp $curboardname;
			fclose(FILE);
			$dlp = &getlog($curboard);
			if( $max_log_days_old && $lastposttime{$curboard} ne $txt{'470'} && $username ne 'Guest' && $dlp < stringtotime( $lastpostrealtime{$curboard} ) ) {
				$new = qq~<img src="$imagesdir/on.gif" alt="$txt{'333'}" border="0">~;
			}
			else { $new = qq~<img src="$imagesdir/off.gif" alt="$txt{'334'}" border="0">~; }
			$yymain .= qq~<tr>
        <td class="windowbg" bgcolor="$color{'windowbg'}" width="8%" align="center" valign="top">$new</td>
        <td class="windowbg2" bgcolor="$color{'windowbg2'}" align="left" width="66%">
        <a name="$curboard"></a>
        <font size=2><a href="$scripturl?board=$curboard"><B>$curboardname</B></a></font></td>
      </tr>~;
		}
	}
	$yymain .= qq~
    </table>
    </td>
  </tr>
</table>~;

# TEMPLATE STUFF STARTS HERE:

	if($yySetCookies1 || $yySetCookies2) { print header(-cookie=>[$yySetCookies1, $yySetCookies2], -charset=>'$yycharset'); }
	else { print header(-status=>'200 OK', -charset=>'$yycharset'); }

	$yytitle = "$mbname";
	$yyrefreshlink = "$scripturl?action=sidebar";
	$yyscripturl = $scripturl;
	$yyuname = $username eq 'Guest' ? qq~$txt{'248'} $txt{'28'}. $txt{'249'} <a href="$cgi;action=login">$txt{'34'}</a> $txt{'377'} <a href="$cgi;action=register">$txt{'97'}</a>.~ : qq~Welcome $realname~;

	fopen(TEMPLATE,"template_sidebar.html") || die("$txt{'23'}: template_sidebar.html");
	@yytemplate = <TEMPLATE>;
	fclose(TEMPLATE);

	for(my $i = 0; $i < @yytemplate; $i++) {
		$curline = $yytemplate[$i];
		if(!$yycopyin && $curline =~ m~<yabb copyright>~) { $yycopyin = 1; }
		if($curline =~ m~<yabb news>~ && $enable_news) {
			fopen(FILE, "$vardir/news.txt");
			@newsmessages = <FILE>;
			fclose(FILE);
			srand;
			$yynews = qq~<b>$txt{'102'}:</b> $newsmessages[int rand(@newsmessages)]~;
		}
		$curline =~ s~<yabb\s+(\w+)>~${"yy$1"}~g;
		print $curline;
	}
	if($yycopyin == 0) {
		print q~<center><font size=5><B>Sorry, the copyright tag <yabb copyright> must be in the template.<BR>Please notify this forum's administrator that this site is using an ILLEGAL copy of YaBB!</B></font></center>~;
	}

	exit;
}

</add before>